//------------------------------ $Keywords ----------------------------------
// SelfImage - Windows disk image backup
// SelfImage.cpp - Project source - framework for the program
// Copyright 2005, Kurt Fitzner <kfitzner@excelcia.org>
//---------------------------------------------------------------------------
// This file is part of SelfImage.
//
// SelfImageis free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License (Version 2) as
// published by the Free Software Foundation.
//
// SelfImage is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// VCS: $Version: 0 $ $Revision: 4 $
/*
$History: **** V 0.1 by kfitzner ****
$History: * selfimage.cpp - 2005-07-30 6:54:02 AM - 875 Bytes
$History: * Initial check-in
$History: **** V 0.2 by kfitzner ****
$History: * selfimage.cpp - 2005-08-06 6:28:53 PM - 3772 Bytes
$History: * Add shared TConfiguration.cpp, initialize utility funcs
$History: **** V 0.3 by kfitzner ****
$History: * selfimage.cpp - 2005-08-17 7:51:34 AM - 3887 Bytes
$History: * Change licensing - only version 2 of the GPL, no later versions
$History: **** Latest ** V 0.4 by kfitzner ** 2005-11-07 2:41:32 AM ****
$History: * Change architecture to threaded I/O
*/
//----------------------------  $NoKeywords ---------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TProgramLog.h"
#include "TConfiguration.h"
#include "SelfImage_Utility.cpp"
//---------------------------------------------------------------------------
TConfiguration *SelfImageConfig = NULL;
TProgramLog    *Log = NULL;
AnsiString      sBinDir;
bool            HaveNTCalls;
//---------------------------------------------------------------------------
USEFORM("SelfImage_MainForm.cpp", MainForm);
USEFORM("SelfImage_ProgressDialog.cpp", ProgressDialog);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  char *buffer;

  try {
    Application->Initialize();

    buffer = (char *)SysGetMem(256);        // Find where the module is sitting and use that as the directory for where the help file is too.
    if (!GetModuleFileName(hInstance, buffer, 256))
      sBinDir = "";
    else
      sBinDir = ExtractFileDir(buffer);
    SysFreeMem(buffer);

    // LOGGING - the following statement initializes the log.  In addition to this, logging must be enabled either
    // by turning on debugging mode, or by #define-ing ENABLE_LOGGING.  If this is not done, then all the log macros
    // will expand to nothing.
    // Set the logging level in the last parameter below - see TProgramLog.h for all the log levels.
    Log = NEWLOG(sBinDir + "\\SelfImage.log", true, false, LOG_STRUCTURE);
    __ENTERPROGRAM__;

    InitializeUtilityFunctions();

    SelfImageConfig = new TConfiguration();
    Application->CreateForm(__classid(TMainForm), &MainForm);
                 Application->Run();

    __LEAVEPROGRAM__;
  }  // try

  catch (Exception &exception) {
    Application->ShowException(&exception);
  }  // catch (Exception &exception)

  catch (...) {
    try {
       throw Exception("");
    }  // try
    catch (Exception &exception) {
       Application->ShowException(&exception);
    }  // catch (Exception &exception)
  }  // catch (...)

  return 0;
}  // WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
//---------------------------------------------------------------------------




